
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class LeadsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const leads = await db.leads.create(
            {
                id: data.id || undefined,
        
        lead_code: data.lead_code
        ||
        null
            ,
            
        name: data.name
        ||
        null
            ,
            
        source: data.source
        ||
        null
            ,
            
        status: data.status
        ||
        null
            ,
            
        estimated_value: data.estimated_value
        ||
        null
            ,
            
        expected_close_at: data.expected_close_at
        ||
        null
            ,
            
        requirements: data.requirements
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await leads.setCustomer( data.customer || null, {
            transaction,
        });
        
        await leads.setOwner( data.owner || null, {
            transaction,
        });
        

        

        

        return leads;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const leadsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                lead_code: item.lead_code
            ||
            null
            ,
            
                name: item.name
            ||
            null
            ,
            
                source: item.source
            ||
            null
            ,
            
                status: item.status
            ||
            null
            ,
            
                estimated_value: item.estimated_value
            ||
            null
            ,
            
                expected_close_at: item.expected_close_at
            ||
            null
            ,
            
                requirements: item.requirements
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const leads = await db.leads.bulkCreate(leadsData, { transaction });

        // For each item created, replace relation files
        

        return leads;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const leads = await db.leads.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.lead_code !== undefined) updatePayload.lead_code = data.lead_code;
        
        
        if (data.name !== undefined) updatePayload.name = data.name;
        
        
        if (data.source !== undefined) updatePayload.source = data.source;
        
        
        if (data.status !== undefined) updatePayload.status = data.status;
        
        
        if (data.estimated_value !== undefined) updatePayload.estimated_value = data.estimated_value;
        
        
        if (data.expected_close_at !== undefined) updatePayload.expected_close_at = data.expected_close_at;
        
        
        if (data.requirements !== undefined) updatePayload.requirements = data.requirements;
        
        
        updatePayload.updatedById = currentUser.id;

        await leads.update(updatePayload, {transaction});

        
        
        if (data.customer !== undefined) {
            await leads.setCustomer(
              
              data.customer,
              
              { transaction }
            );
        }
        
        if (data.owner !== undefined) {
            await leads.setOwner(
              
              data.owner,
              
              { transaction }
            );
        }
        

        
        

        

        return leads;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const leads = await db.leads.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of leads) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of leads) {
                await record.destroy({transaction});
            }
        });


        return leads;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const leads = await db.leads.findByPk(id, options);

        await leads.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await leads.destroy({
            transaction
        });

        return leads;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const leads = await db.leads.findOne(
            { where },
            { transaction },
        );

        if (!leads) {
            return leads;
        }

        const output = leads.get({plain: true});

        
        
        
        
        
        
        
        output.quotes_lead = await leads.getQuotes_lead({
            transaction
        });
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.customer = await leads.getCustomer({
            transaction
        });
        
        
        output.owner = await leads.getOwner({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.customers,
        as: 'customer',
        
        where: filter.customer ? {
          [Op.or]: [
            { id: { [Op.in]: filter.customer.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.customer.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.users,
        as: 'owner',
        
        where: filter.owner ? {
          [Op.or]: [
            { id: { [Op.in]: filter.owner.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.owner.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.lead_code) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'leads',
                        'lead_code',
                        filter.lead_code,
                    ),
                };
            }
            
            if (filter.name) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'leads',
                        'name',
                        filter.name,
                    ),
                };
            }
            
            if (filter.requirements) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'leads',
                        'requirements',
                        filter.requirements,
                    ),
                };
            }
            

            
            

            
            if (filter.estimated_valueRange) {
                const [start, end] = filter.estimated_valueRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    estimated_value: {
                    ...where.estimated_value,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    estimated_value: {
                    ...where.estimated_value,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.expected_close_atRange) {
                const [start, end] = filter.expected_close_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    expected_close_at: {
                    ...where.expected_close_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    expected_close_at: {
                    ...where.expected_close_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.source) {
                where = {
                    ...where,
                source: filter.source,
            };
            }
            
            if (filter.status) {
                where = {
                    ...where,
                status: filter.status,
            };
            }
            


      

      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.leads.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'leads',
                        'name',
                        query,
                    ),
                ],
            };
        }

        const records = await db.leads.findAll({
            attributes: [ 'id', 'name' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['name', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.name,
        }));
    }

    
};

